/**********************************************************************
File Name:              Daytime.c
Dev:                    Daniele De Santis
Email:                  desantis@areasx.com
Web:                    http://www.areasx.com

Versione:               1.0
Data:                   09/08/11
Note Hardware:          FlyPort
Note Software:          OpenPicus IDE v2.0
**********************************************************************/
#include "TCPlib.h"
#include "rtcc.h"

/**********************************************************************
DESCRIPTION:  Interrogazione e sincronizzazione con NTP
//http://www.faqs.org/rfcs/rfc867.html

PARAMETER1:   TimeServer IP o indirizzo del server
               
RETURN VALUE: 0 sincronizzazione fallita
              1 sincronizzazione riuscita
**********************************************************************/
unsigned int InternetDayTime(char* TimeServer){
  TCP_SOCKET   TCPID;
  char         buff[30];
  DWORD        timer;
  t_RTCC       NTPtime;
  char*        p_1;
  char*        p_2;
  char         i;
  char         j;
  char MONTHS[13][4] = {"", "JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SET", "OCT", "NOV", "DEC"};

  TCPID = TCPClientOpen(TimeServer, "13");
  timer = TickGet();
  while((TCPID==INVALID_SOCKET)){
    if(TickGet() - timer > 20 * TICK_SECOND) return 0;
  }
  timer = TickGet();
  while(TCPisConn(TCPID)==FALSE){
    if(TickGet() - timer > 20 * TICK_SECOND) return 0;
  }
  timer = TickGet();
  while(1){
    if(TCPRxLen(TCPID)>=25) {
      TCPRead (TCPID, buff, 25);
      TCPClientClose(TCPID);
      TCPID = INVALID_SOCKET;
      buff[25]=0;
      i=0;
      p_1 = strtok(buff," ");
      while (p_1 != NULL) {
        switch (i){
          case 0:
            NTPtime.day=atoi(p_1);
          break;
          case 1:
            for (j=1; j<=12; j++ ){
              if(strstr(p_1, MONTHS[(int)j])){
                NTPtime.month=j;
                break;
              } 
            }
          break;
          case 2:
            NTPtime.year = (atoi(p_1) - 2000);
          break;
          case 3:
            j=0;
            p_2 = strtok(p_1,":");
            while (p_2 != NULL) {
              switch (j){
                case 0:
                  NTPtime.hour=atoi(p_2);
                break;
                case 1:
                  NTPtime.min=atoi(p_2);
                break;
                case 2:
                  NTPtime.sec=atoi(p_2);
                break;
              }
              j++;
              p_2 = strtok(NULL, ":");
            }
          break;
        }
        i++;
        p_1 = strtok(NULL, " ");
      }
      RTCCWrite (&NTPtime);
      return 1;
    }
    if(TickGet() - timer > 20 * TICK_SECOND) break;
  }
  return 0;
}

